Index: XIOS/dev/branch_yushan/src/attribute_map.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/attribute_map.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/attribute_map.cpp	(revision 1037)
@@ -28,4 +28,9 @@
 
       //---------------------------------------------------------------
+
+      bool CAttributeMap::hasAttribute(const StdString& key) const
+      {
+         return (this->find(key) != this->end());
+      }
 
       void CAttributeMap::clearAttribute(const StdString& key)
Index: XIOS/dev/branch_yushan/src/attribute_map.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/attribute_map.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/attribute_map.hpp	(revision 1037)
@@ -20,5 +20,5 @@
 
             /// Tests ///
-            bool hasAttribute(const StdString & key) const;
+            inline bool hasAttribute(const StdString & key) const;
 
             /// Accesseurs ///
@@ -72,9 +72,4 @@
       };  // class CAttributeMap
 
-      inline bool CAttributeMap::hasAttribute(const StdString& key) const
-      {
-         return (this->find(key) != this->end());
-      }
-
 } // namespace xios
 
Index: XIOS/dev/branch_yushan/src/buffer_client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/buffer_client.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/buffer_client.cpp	(revision 1037)
@@ -7,4 +7,5 @@
 #include "mpi.hpp"
 #include "tracer.hpp"
+
 
 namespace xios
@@ -80,4 +81,6 @@
       traceOn();
       if (flag == true) pending = false;
+
+      //printf("\ncheckbuffer, flag = %d, pending = %d; request = %p, count = %d\n", flag, pending, &request, count);
     }
 
Index: XIOS/dev/branch_yushan/src/buffer_client.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/buffer_client.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/buffer_client.hpp	(revision 1037)
@@ -6,4 +6,7 @@
 #include "mpi.hpp"
 #include "cxios.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace xios
Index: XIOS/dev/branch_yushan/src/client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/client.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/client.cpp	(revision 1037)
@@ -30,4 +30,6 @@
       if (initialized) is_MPI_Initialized=true ;
       else is_MPI_Initialized=false ;
+      
+      //return;
 
 // don't use OASIS
@@ -87,4 +89,5 @@
 
           MPI_Comm_split(CXios::globalComm,myColor,rank,&intraComm) ;
+        
 
           if (CXios::usingServer)
@@ -97,5 +100,5 @@
             MPI_Comm_rank(intraComm,&intraCommRank) ;
             info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
-                 <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
+                 <<" intraCommRank :"<<intraCommRank<<"  serverLeader "<< serverLeader<<endl ;
             MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
           }
@@ -148,4 +151,5 @@
 
       MPI_Comm_dup(intraComm,&returnComm) ;
+
     }
 
@@ -160,4 +164,7 @@
       if (!CXios::isServer)
       {
+      
+        
+        
         int size,rank,globalRank ;
         size_t message_size ;
@@ -165,4 +172,5 @@
         MPI_Comm contextInterComm ;
 
+        
         MPI_Comm_size(contextComm,&size) ;
         MPI_Comm_rank(contextComm,&rank) ;
@@ -173,22 +181,33 @@
         CMessage msg ;
         msg<<idServer<<size<<globalRank ;
-//        msg<<id<<size<<globalRank ;
+
 
         int messageSize=msg.size() ;
-        char * buff = new char[messageSize] ;
-        CBufferOut buffer((void*)buff,messageSize) ;
+        void * buff = new char[messageSize] ;
+        CBufferOut buffer(buff,messageSize) ;
         buffer<<msg ;
-
-        MPI_Send((void*)buff,buffer.count(),MPI_CHAR,serverLeader,1,CXios::globalComm) ;
+        
+        
+
+        MPI_Send(buff,buffer.count(),MPI_CHAR,serverLeader,1,CXios::globalComm) ;
         delete [] buff ;
+        
+        printf("====== Client: begin context_init \n");
+      
 
         MPI_Intercomm_create(contextComm,0,CXios::globalComm,serverLeader,10+globalRank,&contextInterComm) ;
         info(10)<<"Register new Context : "<<id<<endl ;
+        
+        cout<<"Register new Context : "<<id<<endl ;
+              
 
         MPI_Comm inter ;
         MPI_Intercomm_merge(contextInterComm,0,&inter) ;
         MPI_Barrier(inter) ;
-
+        
+        
         context->initClient(contextComm,contextInterComm) ;
+        
+        printf("====== Client: context_init OK\n");
 
         contextInterComms.push_back(contextInterComm);
@@ -220,4 +239,6 @@
 
       MPI_Comm_rank(intraComm,&rank) ;
+      
+      printf("CClient::finalize called isServer = %d\n", CXios::isServer);
  
       if (!CXios::isServer)
@@ -227,4 +248,5 @@
         {
           MPI_Send(&msg,1,MPI_INT,0,0,interComm) ;
+          printf(" CClient : send finalize sign to server 0\n");
         }
       }
@@ -241,5 +263,5 @@
       {
         if (CXios::usingOasis) oasis_finalize();
-        else MPI_Finalize() ;
+        else {MPI_Finalize() ; printf("CClient::finalize called MPI_finalize\n");}
       }
       
Index: XIOS/dev/branch_yushan/src/client.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/client.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/client.hpp	(revision 1037)
@@ -4,4 +4,8 @@
 #include "xios_spl.hpp"
 #include "mpi.hpp"
+#ifdef _usingEP
+//#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
Index: XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp	(revision 1037)
@@ -10,4 +10,8 @@
 #include "utils.hpp"
 #include "mpi_tag.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
@@ -37,14 +41,19 @@
   : H(clientIntraComm), index2InfoMapping_(), indexToInfoMappingLevel_(), nbClient_(0)
 {
+  
   MPI_Comm_size(clientIntraComm, &nbClient_);
   this->computeMPICommLevel();
-  int nbLvl = this->getNbLevel();
+  int nbLvl = this->getNbLevel();  
   sendRank_.resize(nbLvl);
   recvRank_.resize(nbLvl);
   Index2VectorInfoTypeMap indexToVecInfoMap;
-  indexToVecInfoMap.rehash(std::ceil(indexInfoMap.size()/indexToVecInfoMap.max_load_factor()));
-  typename Index2InfoTypeMap::const_iterator it = indexInfoMap.begin(), ite = indexInfoMap.end();
-  for (; it != ite; ++it) indexToVecInfoMap[it->first].push_back(it->second);
-  computeDistributedIndex(indexToVecInfoMap, clientIntraComm, nbLvl-1);
+  indexToVecInfoMap.rehash(std::ceil(indexInfoMap.size()/indexToVecInfoMap.max_load_factor())); 
+  typename Index2InfoTypeMap::const_iterator it = indexInfoMap.begin(), ite = indexInfoMap.end(); 
+  for (; it != ite; ++it)
+  {
+    indexToVecInfoMap[it->first].push_back(it->second);
+  } 
+  
+  computeDistributedIndex(indexToVecInfoMap, clientIntraComm, nbLvl-1); 
 }
 
@@ -179,5 +188,7 @@
   {
     if (0 != recvNbIndexClientCount[idx])
+    {
       recvIndexFromClients(recvRankClient[idx], recvIndexBuff+currentIndex, recvNbIndexClientCount[idx], commLevel, request);
+    }
     currentIndex += recvNbIndexClientCount[idx];
   }
@@ -189,5 +200,11 @@
 
   std::vector<MPI_Status> status(request.size());
+
+  //printf("1(%d): calling wait all for %lu requests\n", clientRank, request.size());
+
   MPI_Waitall(request.size(), &request[0], &status[0]);
+
+
+  //printf("               1(%d): calling wait all for %lu requests OK\n", clientRank, request.size());
 
   CArray<size_t,1>* tmpGlobalIndex;
@@ -294,5 +311,8 @@
 
   std::vector<MPI_Status> statusOnReturn(requestOnReturn.size());
+  //printf("2(%d): calling wait all for %lu requests\n", clientRank, requestOnReturn.size());
   MPI_Waitall(requestOnReturn.size(), &requestOnReturn[0], &statusOnReturn[0]);
+
+  //printf("            2(%d): calling wait all for %lu requests OK\n", clientRank, requestOnReturn.size());
 
   Index2VectorInfoTypeMap indexToInfoMapping;
@@ -363,4 +383,5 @@
                                                             int level)
 {
+  //printf("in computeDistributedIndex(const Index2VectorInfoTypeMap& indexInfoMap, const MPI_Comm& commLevel, int level)\n");
   int clientRank;
   MPI_Comm_rank(commLevel,&clientRank);
@@ -418,4 +439,6 @@
   }
 
+  //printf("check 4 OK. clientRank = %d\n", clientRank);
+
   // Calculate from how many clients each client receive message.
   // Calculate size of buffer for receiving message
@@ -423,4 +446,5 @@
   sendRecvRank(level, sendBuff, sendNbIndexBuff,
                recvRankClient, recvNbIndexClientCount);
+  //printf("sendRecvRank OK\n");
 
   int recvNbIndexCount = 0;
@@ -435,4 +459,6 @@
     recvInfoBuff = new unsigned char[recvNbIndexCount*ProcessDHTElement<InfoType>::typeSize()];
   }
+
+  //printf("check 5 OK. clientRank = %d\n", clientRank);
 
   // If a client holds information about index and the corresponding which don't belong to it,
@@ -447,22 +473,37 @@
     {
       recvIndexFromClients(recvRankClient[idx], recvIndexBuff+currentIndex, recvNbIndexClientCount[idx], commLevel, request);
+
       recvInfoFromClients(recvRankClient[idx],
                           recvInfoBuff+currentIndex*ProcessDHTElement<InfoType>::typeSize(),
                           recvNbIndexClientCount[idx]*ProcessDHTElement<InfoType>::typeSize(),
                           commLevel, request);
+
     }
     currentIndex += recvNbIndexClientCount[idx];
   }
+
+  //printf("check 6 OK. clientRank = %d\n", clientRank);
 
   boost::unordered_map<int, size_t* >::iterator itbIndex = client2ClientIndex.begin(), itIndex,
                                                 iteIndex = client2ClientIndex.end();
   for (itIndex = itbIndex; itIndex != iteIndex; ++itIndex)
+  {
     sendIndexToClients(itIndex->first, itIndex->second, sendNbIndexBuff[itIndex->first-groupRankBegin], commLevel, request);
+
+  }
+
+  //printf("check 7 OK. clientRank = %d\n", clientRank);
+
   boost::unordered_map<int, unsigned char*>::iterator itbInfo = client2ClientInfo.begin(), itInfo,
                                                       iteInfo = client2ClientInfo.end();
   for (itInfo = itbInfo; itInfo != iteInfo; ++itInfo)
+  {
     sendInfoToClients(itInfo->first, itInfo->second, sendNbInfo[itInfo->first-groupRankBegin], commLevel, request);
 
+  }
+
+  //printf("check 8 OK. clientRank = %d\n", clientRank);
   std::vector<MPI_Status> status(request.size());
+
   MPI_Waitall(request.size(), &request[0], &status[0]);
 
@@ -480,8 +521,12 @@
     {
       ProcessDHTElement<InfoType>::unpackElement(infoValue, infoBuff, infoIndex);
+      unsigned long pp = *(recvIndexBuff+currentIndex+i);
+      
       indexToInfoMapping[*(recvIndexBuff+currentIndex+i)].push_back(infoValue);
     }
     currentIndex += count;
   }
+
+  //printf("check 9 OK. clientRank = %d\n", clientRank);
 
   if (0 != recvNbIndexCount)
@@ -498,4 +543,5 @@
       delete [] it->second;
 
+  //printf("check 10 OK. clientRank = %d\n", clientRank);
   // Ok, now do something recursive
   if (0 < level)
@@ -523,4 +569,5 @@
   MPI_Request request;
   requestSendIndex.push_back(request);
+
   MPI_Isend(indices, indiceSize, MPI_UNSIGNED_LONG,
             clientDestRank, MPI_DHT_INDEX, clientIntraComm, &(requestSendIndex.back()));
@@ -541,4 +588,5 @@
   MPI_Request request;
   requestRecvIndex.push_back(request);
+
   MPI_Irecv(indices, indiceSize, MPI_UNSIGNED_LONG,
             clientSrcRank, MPI_DHT_INDEX, clientIntraComm, &(requestRecvIndex.back()));
@@ -560,5 +608,5 @@
   MPI_Request request;
   requestSendInfo.push_back(request);
-
+  //printf("MPI_IsendInfo(info, infoSize, MPI_CHAR,... char count = %d, dest = %d, buf_size = %d\n", infoSize, clientDestRank, sizeof(*info) );
   MPI_Isend(info, infoSize, MPI_CHAR,
             clientDestRank, MPI_DHT_INFO, clientIntraComm, &(requestSendInfo.back()));
@@ -668,6 +716,10 @@
     ++nRequest;
   }
-
+  
+  int clientRank;
+  MPI_Comm_rank(this->internalComm_,&clientRank);
+  //printf("4(%d): calling wait all for %lu requests\n", clientRank, sendNbRank.size()+recvNbRank.size());
   MPI_Waitall(sendNbRank.size()+recvNbRank.size(), &request[0], &requestStatus[0]);
+  //printf("        4(%d): calling wait all for %lu requests OK\n", clientRank, sendNbRank.size()+recvNbRank.size());
 }
 
@@ -686,4 +738,7 @@
                                                  std::vector<int>& recvNbRank, std::vector<int>& recvNbElements)
 {
+  int myRank;
+  MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
+  //printf("myRank = %d, in sendRecvRank(int level, const std::vector<int>& sendNbRank, const std::vector<int>& sendNbElements, std::vector<int>& recvNbRank, std::vector<int>& recvNbElements)\n", myRank);
   int groupBegin = this->getGroupBegin()[level];
 
@@ -702,8 +757,12 @@
   for (int idx = 0; idx < recvBuffSize; ++idx)
   {
+    //printf("myRank = %d starts irecv with src = %d, tag = %d, idx = %d\n", myRank, recvRank[idx], MPI_DHT_INDEX_0, idx);
     MPI_Irecv(&recvBuff[0]+2*idx, 2, MPI_INT,
               recvRank[idx], MPI_DHT_INDEX_0, this->internalComm_, &request[nRequest]);
+    //printf("myRank = %d MPI_Irecv OK, idx = %d, nRequest = %d\n", myRank, idx, nRequest);
     ++nRequest;
   }
+
+  //printf("myRank = %d, check 1 OK\n", myRank);
 
   for (int idx = 0; idx < sendBuffSize; ++idx)
@@ -716,10 +775,23 @@
   for (int idx = 0; idx < sendBuffSize; ++idx)
   {
+    //printf("myRank = %d starts isend with dest = %d, tag = %d, idx = %d\n", myRank, sendRank[idx], MPI_DHT_INDEX_0, idx);
     MPI_Isend(&sendBuff[idx*2], 2, MPI_INT,
               sendRank[idx], MPI_DHT_INDEX_0, this->internalComm_, &request[nRequest]);
+    //printf("myRank = %d MPI_Isend OK, idx = %d, nRequest = %d\n", myRank, idx, nRequest);
     ++nRequest;
   }
 
+  MPI_Barrier(this->internalComm_);
+
+  //printf("myRank = %d, check 2 OK\n", myRank);
+
+  int clientRank;
+  MPI_Comm_rank(this->internalComm_,&clientRank);
+
+  //printf("5(%d): calling wait all for %lu requests\n", myRank, sendBuffSize+recvBuffSize);
   MPI_Waitall(sendBuffSize+recvBuffSize, &request[0], &requestStatus[0]);
+  //printf("            5(%d): calling wait all for %lu requests OK\n", myRank, sendBuffSize+recvBuffSize);
+  //printf("check 3 OK\n");
+
   int nbRecvRank = 0, nbRecvElements = 0;
   recvNbRank.clear();
@@ -733,5 +805,6 @@
     }
   }
-}
-
-}
+  //printf("check 4 OK\n");
+}
+
+}
Index: XIOS/dev/branch_yushan/src/client_server_mapping.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/client_server_mapping.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/client_server_mapping.hpp	(revision 1037)
@@ -14,4 +14,8 @@
 #include "mpi.hpp"
 #include <boost/unordered_map.hpp>
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios {
Index: XIOS/dev/branch_yushan/src/config/field_attribute.conf
===================================================================
--- XIOS/dev/branch_yushan/src/config/field_attribute.conf	(revision 1036)
+++ XIOS/dev/branch_yushan/src/config/field_attribute.conf	(revision 1037)
@@ -11,5 +11,4 @@
 DECLARE_ATTRIBUTE(int,       level)
 DECLARE_ATTRIBUTE(int,       prec)
-DECLARE_ATTRIBUTE(StdString, expr)
 
 DECLARE_ATTRIBUTE(bool,      enabled)
@@ -34,5 +33,2 @@
 DECLARE_ATTRIBUTE(bool,      ts_enabled)
 DECLARE_ATTRIBUTE(CDuration, ts_split_freq)
-
-DECLARE_ATTRIBUTE(StdString, cell_methods)
-DECLARE_ENUM4(cell_methods_mode,  overwrite, prefix, suffix, none)
Index: XIOS/dev/branch_yushan/src/config/interpolate_domain_attribute.conf
===================================================================
--- XIOS/dev/branch_yushan/src/config/interpolate_domain_attribute.conf	(revision 1036)
+++ XIOS/dev/branch_yushan/src/config/interpolate_domain_attribute.conf	(revision 1037)
@@ -1,8 +1,7 @@
 /* GLOBAL */
+DECLARE_ATTRIBUTE(StdString, file)
 DECLARE_ATTRIBUTE(int, order)
 DECLARE_ATTRIBUTE(bool, renormalize)
 
 /* Write interpolation weights into file */
-DECLARE_ENUM3(mode,compute,read,read_or_compute)
-DECLARE_ATTRIBUTE(StdString, weight_filename)
-DECLARE_ATTRIBUTE(bool, write_weight)
+DECLARE_ENUM2(mode,write,read)
Index: XIOS/dev/branch_yushan/src/context_client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1037)
@@ -50,6 +50,4 @@
         for (int i = 0; i < serverByClient; i++)
           ranksServerLeader.push_back(rankStart + i);
-
-        ranksServerNotLeader.resize(0);
       }
       else
@@ -62,6 +60,4 @@
           if (clientRank % (clientByServer + 1) == 0)
             ranksServerLeader.push_back(clientRank / (clientByServer + 1));
-          else
-            ranksServerNotLeader.push_back(clientRank / (clientByServer + 1));
         }
         else
@@ -70,7 +66,5 @@
           if (rank % clientByServer == 0)
             ranksServerLeader.push_back(remain + rank / clientByServer);
-          else
-            ranksServerNotLeader.push_back(remain + rank / clientByServer);
-        }        
+        }
       }
 
@@ -85,68 +79,22 @@
     {
       list<int> ranks = event.getRanks();
-
       if (!event.isEmpty())
       {
         list<int> sizes = event.getSizes();
 
-        // We force the getBuffers call to be non-blocking on the servers
-        list<CBufferOut*> buffList;
-        bool couldBuffer = getBuffers(ranks, sizes, buffList, !CXios::isClient);
-
-        if (couldBuffer)
-        {
-          event.send(timeLine, sizes, buffList);
-
-          checkBuffers(ranks);
-
-          if (isAttachedModeEnabled()) // couldBuffer is always true in attached mode
-          {
-            waitEvent(ranks);
-            CContext::setCurrent(context->getId());
-          }
-        }
-        else
-        {
-          tmpBufferedEvent.ranks = ranks;
-          tmpBufferedEvent.sizes = sizes;
-
-          for (list<int>::const_iterator it = sizes.begin(); it != sizes.end(); it++)
-            tmpBufferedEvent.buffers.push_back(new CBufferOut(*it));
-
-          event.send(timeLine, tmpBufferedEvent.sizes, tmpBufferedEvent.buffers);
-        }
+        list<CBufferOut*> buffList = getBuffers(ranks, sizes);
+
+        event.send(timeLine, sizes, buffList);
+
+        checkBuffers(ranks);
+      }
+
+      if (isAttachedModeEnabled())
+      {
+        waitEvent(ranks);
+        CContext::setCurrent(context->getId());
       }
 
       timeLine++;
-    }
-
-    /*!
-     * Send the temporarily buffered event (if any).
-     *
-     * \return true if a temporarily buffered event could be sent, false otherwise 
-     */
-    bool CContextClient::sendTemporarilyBufferedEvent()
-    {
-      bool couldSendTmpBufferedEvent = false;
-
-      if (hasTemporarilyBufferedEvent())
-      {
-        list<CBufferOut*> buffList;
-        if (getBuffers(tmpBufferedEvent.ranks, tmpBufferedEvent.sizes, buffList, true)) // Non-blocking call
-        {
-          list<CBufferOut*>::iterator it, itBuffer;
-
-          for (it = tmpBufferedEvent.buffers.begin(), itBuffer = buffList.begin(); it != tmpBufferedEvent.buffers.end(); it++, itBuffer++)
-            (*itBuffer)->put((char*)(*it)->start(), (*it)->count());
-
-          checkBuffers(tmpBufferedEvent.ranks);
-
-          tmpBufferedEvent.clear();
-
-          couldSendTmpBufferedEvent = true;
-        }
-      }
-
-      return couldSendTmpBufferedEvent;
     }
 
@@ -159,32 +107,30 @@
     {
       parentServer->server->setPendingEvent();
+      size_t pendingmapSize;
       while (checkBuffers(ranks))
       {
-        parentServer->server->listen();
-        parentServer->server->checkPendingRequest();
+        parentServer->server->listen(); 
+        parentServer->server->checkPendingRequest(); 
       }
 
       while (parentServer->server->hasPendingEvent())
       {
-       parentServer->server->eventLoop();
+       parentServer->server->eventLoop(); //printf("parentServer->server->eventLoop()\n");
       }
     }
 
     /*!
-     * Get buffers for each connection to the servers. This function blocks until there is enough room in the buffers unless
-     * it is explicitly requested to be non-blocking.
-     *
-     * \param [in] serverList list of rank of connected server
-     * \param [in] sizeList size of message corresponding to each connection
-     * \param [out] retBuffers list of buffers that can be used to store an event
-     * \param [in] nonBlocking whether this function should be non-blocking
-     * \return whether the already allocated buffers could be used
+    Setup buffer for each connection to server and verify their state to put content into them
+    \param [in] serverList list of rank of connected server
+    \param [in] sizeList size of message corresponding to each connection
+    \return List of buffer input which event can be placed
     */
-    bool CContextClient::getBuffers(const list<int>& serverList, const list<int>& sizeList, list<CBufferOut*>& retBuffers, bool nonBlocking /*= false*/)
+    list<CBufferOut*> CContextClient::getBuffers(list<int>& serverList, list<int>& sizeList)
     {
-      list<int>::const_iterator itServer, itSize;
+      list<int>::iterator itServer, itSize;
       list<CClientBuffer*> bufferList;
-      map<int,CClientBuffer*>::const_iterator it;
+      map<int,CClientBuffer*>::iterator it;
       list<CClientBuffer*>::iterator itBuffer;
+      list<CBufferOut*>  retBuffer;
       bool areBuffersFree;
 
@@ -212,14 +158,12 @@
           context->server->listen();
         }
-      } while (!areBuffersFree && !nonBlocking);
+      } while (!areBuffersFree);
       CTimer::get("Blocking time").suspend();
 
-      if (areBuffersFree)
-      {
-        for (itBuffer = bufferList.begin(), itSize = sizeList.begin(); itBuffer != bufferList.end(); itBuffer++, itSize++)
-          retBuffers.push_back((*itBuffer)->getBuffer(*itSize));
-      }
-
-      return areBuffersFree;
+      for (itBuffer = bufferList.begin(), itSize = sizeList.begin(); itBuffer != bufferList.end(); itBuffer++, itSize++)
+      {
+        retBuffer.push_back((*itBuffer)->getBuffer(*itSize));
+      }
+      return retBuffer;
    }
 
@@ -291,6 +235,10 @@
        if (ratio < minBufferSizeEventSizeRatio) minBufferSizeEventSizeRatio = ratio;
      }
+     #ifdef _usingMPI
      MPI_Allreduce(MPI_IN_PLACE, &minBufferSizeEventSizeRatio, 1, MPI_DOUBLE, MPI_MIN, intraComm);
-
+     #elif _usingEP
+     MPI_Allreduce(&minBufferSizeEventSizeRatio, &minBufferSizeEventSizeRatio, 1, MPI_DOUBLE, MPI_MIN, intraComm);
+     #endif
+     
      if (minBufferSizeEventSizeRatio < 1.0)
        ERROR("void CContextClient::setBufferSize(const std::map<int,StdSize>& mapSize, const std::map<int,StdSize>& maxEventSize)",
@@ -301,22 +249,4 @@
                           + 1;                                   // the other local buffer might contain only one event
    }
-
-  /*!
-  Get leading server in the group of connected server
-  \return ranks of leading servers
-  */
-  const std::list<int>& CContextClient::getRanksServerNotLeader(void) const
-  {
-    return ranksServerNotLeader;
-  }
-
-  /*!
-  Check if client connects to leading server
-  \return connected(true), not connected (false)
-  */
-  bool CContextClient::isServerNotLeader(void) const
-  {
-    return !ranksServerNotLeader.empty();
-  }
 
   /*!
@@ -354,13 +284,5 @@
    {
      map<int,CClientBuffer*>::iterator itBuff;
-     bool stop = false;
-
-     CTimer::get("Blocking time").resume();
-     while (hasTemporarilyBufferedEvent())
-     {
-       checkBuffers();
-       sendTemporarilyBufferedEvent();
-     }
-     CTimer::get("Blocking time").suspend();
+     bool stop = true;
 
      CEventClient event(CContext::GetType(), CContext::EVENT_ID_CONTEXT_FINALIZE);
@@ -376,12 +298,9 @@
 
      CTimer::get("Blocking time").resume();
-     while (!stop)
+     while (stop)
      {
        checkBuffers();
-       if (hasTemporarilyBufferedEvent())
-         sendTemporarilyBufferedEvent();
-
-       stop = true;
-       for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) stop &= !itBuff->second->hasPendingRequest();
+       stop = false;
+       for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) stop |= itBuff->second->hasPendingRequest();
      }
      CTimer::get("Blocking time").suspend();
Index: XIOS/dev/branch_yushan/src/context_client.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_client.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/context_client.hpp	(revision 1037)
@@ -10,4 +10,8 @@
 #include "mpi.hpp"
 #include "registry.hpp"
+#ifdef _usingEP
+//#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
@@ -31,9 +35,8 @@
       // Send event to server
       void sendEvent(CEventClient& event);
-      bool sendTemporarilyBufferedEvent();
       void waitEvent(list<int>& ranks);
 
-      // Functions to set/get buffers
-      bool getBuffers(const list<int>& serverList, const list<int>& sizeList, list<CBufferOut*>& retBuffers, bool nonBlocking = false);
+      // Functions relates to set/get buffers
+      list<CBufferOut*> getBuffers(list<int>& serverlist, list<int>& sizeList);
       void newBuffer(int rank);
       bool checkBuffers(list<int>& ranks);
@@ -42,11 +45,7 @@
 
       bool isServerLeader(void) const;
-      bool isServerNotLeader(void) const;
       const std::list<int>& getRanksServerLeader(void) const;
-      const std::list<int>& getRanksServerNotLeader(void) const;
 
       bool isAttachedModeEnabled() const;
-
-      bool hasTemporarilyBufferedEvent() const { return !tmpBufferedEvent.isEmpty(); };
 
       // Close and finalize context client
@@ -79,20 +78,4 @@
       StdSize maxBufferedEvents;
 
-      struct {
-        std::list<int> ranks, sizes;
-        std::list<CBufferOut*> buffers;
-
-        bool isEmpty() const { return ranks.empty(); };
-        void clear() {
-          ranks.clear();
-          sizes.clear();
-
-          for (std::list<CBufferOut*>::iterator it = buffers.begin(); it != buffers.end(); it++)
-            delete *it;
-
-          buffers.clear();
-        };
-      } tmpBufferedEvent; //! Event temporarily buffered (used only on the server)
-
       //! Context for server (Only used in attached mode)
       CContext* parentServer;
@@ -100,7 +83,4 @@
       //! List of server ranks for which the client is leader
       std::list<int> ranksServerLeader;
-
-      //! List of server ranks for which the client is not leader
-      std::list<int> ranksServerNotLeader;
 
     public: // Some function should be removed in the future
Index: XIOS/dev/branch_yushan/src/context_server.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_server.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/context_server.cpp	(revision 1037)
@@ -57,10 +57,9 @@
   }
 
-  bool CContextServer::eventLoop(bool enableEventsProcessing /*= true*/)
+  bool CContextServer::eventLoop(void)
   {
     listen();
     checkPendingRequest();
-    if (enableEventsProcessing)
-      processEvents();
+    processEvents();
     return finished;
   }
@@ -77,4 +76,5 @@
     for(rank=0;rank<commSize;rank++)
     {
+      //printf("in CContextServer::listen, rank = %d, commSize = %d, pendingRequest.find(rank) = %d\n", rank, commSize, pendingRequest.find(rank));
       if (pendingRequest.find(rank)==pendingRequest.end())
       {
@@ -85,4 +85,5 @@
         {
           it=buffers.find(rank);
+          
           if (it==buffers.end()) // Receive the buffer size and allocate the buffer
           {
@@ -91,7 +92,9 @@
             mapBufferSize_.insert(std::make_pair(rank, buffSize));
             it=(buffers.insert(pair<int,CServerBuffer*>(rank,new CServerBuffer(buffSize)))).first;
+            //printf("find message, is buffer end, receiving, buffSize = %d, rank = %d, commSize = %d\n", buffSize, rank, commSize);
           }
           else
           {
+            
             MPI_Get_count(&status,MPI_CHAR,&count);
             if (it->second->isBufferFree(count))
@@ -100,4 +103,5 @@
               MPI_Irecv(addr,count,MPI_CHAR,rank,20,interComm,&pendingRequest[rank]);
               bufferRequest[rank]=addr;
+              //printf("find message, i-receiving to buffer %p, rank = %d, commSize = %d\n", addr, rank, commSize);
             }
           }
@@ -116,4 +120,6 @@
     int count;
     MPI_Status status;
+
+    //printf("enter checkPendingRequest\n");
 
     for(it=pendingRequest.begin();it!=pendingRequest.end();it++)
@@ -185,5 +191,5 @@
          // The best way to properly solve this problem will be to use the event scheduler also in attached mode
          // for now just set up a MPI barrier
-         if (!CServer::eventScheduler && CXios::isServer) MPI_Barrier(intraComm) ;
+         if (!CServer::eventScheduler) MPI_Barrier(intraComm) ;
 
          CTimer::get("Process events").resume();
Index: XIOS/dev/branch_yushan/src/context_server.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_server.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/context_server.hpp	(revision 1037)
@@ -15,5 +15,5 @@
 
     CContextServer(CContext* parent,MPI_Comm intraComm,MPI_Comm interComm) ;
-    bool eventLoop(bool enableEventsProcessing = true);
+    bool eventLoop(void) ;
     void listen(void) ;
     void checkPendingRequest(void) ;
